from zope.component import getUtility
from zope.formlib import form
from zope.interface import implements, Interface
from zope import schema
from zope.i18nmessageid import MessageFactory

from plone.fieldsets.fieldsets import FormFieldsets
from plone.app.controlpanel.form import ControlPanelForm
from jyu.pathkey import _
from jyu.pathkey.interfaces import IPathkeyControlPanelForm
from jyu.pathkey.interfaces import IPathkeyFinnishForm, IPathkeyEnglishForm, IPathkeyListing

# from Products.CMFDefault.formlib.schema import ProxyFieldProperty
# from Products.CMFDefault.formlib.schema import SchemaAdapterBase
from zope.app.component.hooks import getSite
# from plone.locking.interfaces import ILockSettings
from Products.CMFCore.utils import getToolByName

_ = MessageFactory('jyu.pathkey')

class PathkeyControlPanelForm(ControlPanelForm):
    """ Pathkey control panel """
    implements(IPathkeyControlPanelForm)

    pathkey_finnish = FormFieldsets(IPathkeyFinnishForm)
    pathkey_finnish.id = 'pathkey_finnish'
    pathkey_finnish.label = _(u"Additional Finnish content")

    pathkey_english = FormFieldsets(IPathkeyEnglishForm)
    pathkey_english.id = 'pathkey_english'
    pathkey_english.label = _(u"Additional English content")

    pathkey_listing = FormFieldsets(IPathkeyListing)
    pathkey_listing.id = 'pathkey_listing'
    pathkey_listing.label = _(u"List all pathkeys")

    form_fields = FormFieldsets(pathkey_finnish, pathkey_english, pathkey_listing)

    form_name = _(u"Pathkey settings")
    label = _(u"Pathkey settings")
    description = _(u"Here you can customize the contents of the form requesting pathkey.")



#class PathkeyControlPanelAdapter(SchemaAdapterBase):
#    implements(IPathkeySettings, ILockSettings)
#    
#    def __init__(self, context):
#        super(PathkeyControlPanelAdapter, self).__init__(context)
#        self.portal = getSite()
#        pprop = getToolByName(self.portal, 'portal_properties')
#        self.context = pprop.site_properties
#        self.encoding = pprop.site_properties.default_charset
#    
#    pathkeyTitle = ProxyFieldProperty(IPathkeySettings['pathkeyTitle'])
#    pathkeyDescription = ProxyFieldProperty(IPathkeySettings['pathkeyDescription'])
